import sys
import argparse
import pyfiglet
import time
from loader import *


def banner():
	ascii_banner = pyfiglet.figlet_format("Spec`POC")
	print(ascii_banner)
if __name__ == '__main__':
	banner()
	print("[*] starting at {0}\n\n".format(time.strftime("%X")))
	parser = argparse.ArgumentParser(usage='spec.POC management tool',description='description:Apply scripts to test vulnerable sites')
	parser = argparse.ArgumentParser(usage='POC management tool',description='description:Apply scripts to test vulnerable sites')
	parser.add_argument("--url","-u",type = str,help="Vulnerability testing for a single url")
	parser.add_argument("--file","-f",type = str,help="The url in the file is tested for weaknesses one by one")
	parser.add_argument("--zoomeye","-z",action="store_true",help="Use zoomeye to get urls and test for weaknesses one by one")
	parser.add_argument("--script","-s",type = str,required=True,help="Which script to use for vulnerability testing")
	parser.add_argument("--app","-a",type = str,help="Test that known system")
	parser.add_argument("--page","-p",type = int,help="Zoomeye queries the pages of a url")
	parser.add_argument("--thread","-t",type = int,help="The thread used for the attack is 10 by default")
	parser.add_argument("--mode","-m",type = str,required=True,help="Which mode of detection to use")
	args = parser.parse_args()
	try:
		if args.url:
			module = load_string_to_module('oneurl.py')
			module.OneUrl(args.url,args.script,args.mode).main()
		elif args.file:
			module = load_string_to_module('fileurl.py')
			module.FileUrl(args.file,args.script,args.mode,args.thread).main()
		elif args.zoomeye:
			module = load_string_to_module('zoomeye.py')
			module.Zoomeye(args.app,args.script,args.page,args.mode,args.thread).main()
		else:
			print("Please enter which mode to use!")
			sys.exit()
	finally:
		print("\n\n[*] shutting down at {0}\n\n".format(time.strftime("%X")))