from loader import *
import os
import concurrent.futures
import sys

class FileUrl():
	def __init__(self,file,script,mode,threads):
		self.file = file
		self.script = script
		self.mode = mode
		self.threads = threads
		self.urls = []
	def get_url(self):
		try:
			f = open(self.file,'r')
		except FileNotFoundError:
			print("ERROR:No such file or directory:{}".format(self.file))
			sys.exit()
		for url in f:
			url = url.strip('\n')
			url = self.check_url(url)
			self.urls.append(url)
	def main(self):
		self.get_url()
		self.pool()
	def pool(self):
		try:
			with concurrent.futures.ThreadPoolExecutor(max_workers=self.threads) as executor:
				executor.map(self.call_back, self.urls)
		except:
			print("Zoomeye gets IP errors")
			sys.exit()
	def call_back(self,url):
		try:
			module = load_string_to_module(self.script)
		except AttributeError:
			print("ERROR : 'NoneType' object has no attribute 'loader'")
			sys.exit()
		try:
			if self.mode:
				func = "module."+self.mode+"(\""+url+"\")"
				eval(func)
			else:
				print("Warning : Determine whether the test module is selected")
		except AttributeError:
			print("ERROR : module '{}' has no attribute '{}'".format(self.script,self.mode))
			sys.exit()
	def check_url(self,url):
		if ('http://' in url) or ('https://' in url):
			return url
		else:
			url = 'http://'+url
			return url